#!/usr/bin/runhaskell

import Distribution.Simple
import Distribution.PackageDescription
import Distribution.Simple.LocalBuildInfo
import Distribution.Simple.Setup
import System.Environment
import System.FilePath
import System.Process

main = defaultMainWithHooks (simpleUserHooks { postConf = hook })

hook :: Args -> ConfigFlags -> PackageDescription -> LocalBuildInfo -> IO ()
hook _args flags pd lbi = do
  case compilerId (compiler lbi) of
    CompilerId GHC _ -> do
      args <- getArgs
      let distDir = takeDirectory (buildDir lbi)
      -- We need to pre-build this package so the required _dyn.o file
      -- already exists when the profiling library is built.
      _ <- readProcess "cabal" ["configure", "--builddir=" ++ distDir] ""
      _ <- readProcess "cabal" ["build", "--builddir=" ++ distDir] ""
      _ <- readProcess "cabal" args ""
      return ()
    _ -> return ()
